/*****************************************************************
*****************    CRG         *************************
******************************************************************
FICHERO criter.c: Este modulo contiene los procedimientos que
permiten calcular las reglas CRG de las ecuaciones
************************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>

#include "const.h"
#include "estruc.h"
#include "glovar.h"

/* Prototipos de funciones externas, definidas en Procesos auxiliares.
   No todas estas funciones son empleadas en "criter.c". */ 
#include "proaux.h"

/* Prototipos de funciones externas, definidas en Fichero de Unificacion
Sintactica. No todas estas funciones son empleadas en "ob.c". */
#include "unific.h"

/* Prototipos de funciones externas, definidas en Fichero de Unificacion
   Semantica. No todas estas funciones son empleadas en "ob.c". */
#include "narrow.h"


extern struct stat *genstat(struct lista *obj);
extern struct funcs *gensimesc(struct lista *ini, struct funcs **sbfin);
extern void cob_ecu(struct arbol *ecua);

int vbles=0; /*indica si hay variables o no en la ecuacin para crg*/
/* pequeo test de terminacin*/
/* si la regla solo esta encabezada por variables en su parte izquierda y tiene el mismo simbolo de funcin de cabeza en la derecha y en la izquierda
   devuelve 1*/

PRIVATE int solo_vbls_lhs (struct arbol *ecu)
{
  struct arbol *aux=NULL;
  struct lista *ocus,*fin,*laux=NULL;
  /*primero comprobamos que en la parte izquierda solo vbles*/
  
  if (terminacion==0) return 0;
  
  for (aux=ecu->hijo;aux;aux=aux->herm)
    {
      if  ( (isupper(aux->oc[0])) ||(aux->oc[0]!='_'))
	{return 0;}
    }
  /*hay solo vbles, continuamos*/
   /*tomamos ocurrencias no variables parte derecha*/ 
  ocus=ocubas(&ecu->herm,&fin);
  for(laux=ocus;laux;laux=laux->sig)
    {
      /*buscamos que haya una llamada a la misma funcin, con todo vbles*/
      if (strcmp(laux->ecu->oc,ecu->oc)==0) 
	{
	  /* mismo simbolo en cabez lhs y rhs */
	  borraocu(ocus);
	  return 1; /* hemos encontrado f(X)= f(X)*/
	}
    }
  borraocu(ocus);
  return 0;
    
}
/* produce una nueva ecuacion cambiando una ocurrencia por una variable nueva
   parametros: 1 ecuacion, 2 ocu vieja */

PRIVATE struct lista *nueva_gen(struct arbol *ecua,struct oc_pos *pos, char *vbl)
{
  struct arbol *auxe0,*auxe,*auxe1;
  struct lista  *auxli;
  /* obtenemos la posicion*/
  auxe1=ret_ocu_pos(pos,pos->valor,ecua);
  if (!auxe1) return NULL;
  /* si tenemos que generar la variable vbl=='\0'*/
  if (vbl[0]=='\0') fresh(vbl);
  auxe0=nouarbol();
  strcpy(auxe0->oc,vbl);
  auxe=modifica(ecua,auxe1,auxe0);
  borraecu(auxe0);
  auxli=noulista();
  auxli->ecu=auxe;
  return auxli;
}


/* eliminamos los que no traten bien los ejmeplos positivos*/

PRIVATE struct lista *eje_pos(struct lista **uini)
{
  struct lista *auxl,*auxlp,*auxe,*auxep,*auxe1,*auxl0;
  struct stat *S, /* puntero al estado de narrowing inicial */
    *E; /* puntero a la lista de estados de exito.
		     Contienen las repuestas computadas. */
  struct funcs *funes;
  struct arbol *atmp,*vell;
  struct stat *tstat;
  struct subs *tsub;
  int t=0;
  char vbl[10];
  
  auxe=noulista();
  auxep=noulista();
  fresh(vbl);
  auxl=*uini;
  auxlp=*uini;
  while(auxl)
    {
      auxe->ecu=auxl->ecu;
      gensimesc(auxe,&funes);
      t=0;
      for (auxe1=ejempini;auxe1;auxe1=auxe1->sig)
	{    
	  atmp= copiecu(auxe1->ecu);
	  auxep->ecu=atmp;
	  vell=copiecu(auxep->ecu->herm);
	  strcpy(auxep->ecu->herm->oc,vbl);
	  borraecu(auxep->ecu->herm->herm);auxep->ecu->herm->herm=NULL;	
	  borraecu(auxep->ecu->herm->hijo);auxep->ecu->herm->hijo=NULL;
	  start_st('C');
	  
	  S = genstat(auxep);
	  E = narrower(S,auxe,funes,0); 
	  stop_st();
	  borrastat(S);
	  tstat=E->sig;/*el primero siempre es la simple sustitucion*/
	  if (tstat)
	  {
	    for(tsub=tstat->alfa;strcmp(tsub->var,vbl);tsub=tsub->sig);
	    if (!comp_arb(vell,tsub->term))
	      {  
		borrastat(E);
		borraecu(atmp);
		borraecu(vell);
			t=1;
			break;
	      }
	  }
	  borrastat(E);
	  borraecu(atmp);
	  borraecu(vell);
	}
      borrafun(funes);
      if (t==1) 
	{
	  /*hay que eliminarlo de la lista*/
	  if (auxl==*uini) 
	    {*uini=(*uini)->sig;
	    auxl->sig=NULL;
	    borralis(auxl);
	    auxl=*uini;
	    auxlp=*uini;}
	  else {auxlp->sig=auxl->sig;
	  auxl0=auxl;
	  auxl=auxl->sig;
	  auxl0->sig=NULL;
	  borralis(auxl0);}
	}
      else 
	{
	  auxlp=auxl;
	  auxl=auxl->sig;
	}
      
    }
  /*evita que se borren ecuaciones de la teoria*/
  auxep->ecu=NULL;
  borralis(auxep); 	
  auxe->ecu=NULL;
  borralis(auxe); 
return auxlp;
}   

/* eliminamos las que cubran ejemplos negativos*/

PRIVATE struct lista *no_eje_neg(struct lista **uini)
{
  struct lista *auxl,*auxlp,*auxe,*auxep,*auxe1,*auxl0;
  struct stat *S, /* puntero al estado de narrowing inicial */
    *E=NULL; /* puntero a la lista de estados de exito.
	   Contienen las repuestas computadas. */
  struct funcs *funes;
  
  auxep=noulista();
  auxe=noulista();
  /* si se indica la utilizacin del bkgr se une a la regla*/
  if (bkg) auxep->sig=listaini;   

  auxl=*uini;
  auxlp=*uini;
  while(auxl)
    {
      auxe->ecu=auxl->ecu;
      gensimesc(auxe,&funes);
      for (auxe1=ejemnini;auxe1;auxe1=auxe1->sig)
	{    
	  auxep->ecu=auxe1->ecu;
	  start_st('C');
	  S = genstat(auxep);
	  E = narrower(S,auxe,funes,1); borrastat(S);
	  if (E!=NULL) 
	    {
	      borrastat(E);
	      stop_st();
	      break;
	    }
	  borrastat(E);
	  stop_st();
	}
      borrafun(funes);
      if (E!=NULL) 
	{
	  /*lo cubre hay que eliminarlo de la lista*/	
	  if (auxl==*uini) 
	    {
	      *uini=(*uini)->sig;
	      auxl->sig=NULL;
	      borralis(auxl);
	      auxl=*uini;
	      auxlp=*uini;
	    }
	  else 
	    {
	      auxlp->sig=auxl->sig;  /* modificacion antes cerrabams aqui*/
	      auxl0=auxl;
	      auxl=auxl->sig;
	      auxl0->sig=NULL;
	      borralis(auxl0);
	    }
	}
      else 
	{
	  auxlp=auxl;
	  auxl=auxl->sig;
	}
    }
  /*evita que se borren ecuaciones de la teoria*/
  auxep->ecu=NULL;
  auxep->sig=NULL;
  borralis(auxep); 	
  auxe->ecu=NULL;
  borralis(auxe); 
  return auxlp;
}   

/* por cada variable con mas de una aparicin en la ecuacin en la parte izquierda le asigna una constante del tipo @..., para que se generen los crg*/
PRIVATE void asig_var(struct arbol **arb)
{
  struct lista *u,*ufin;
  struct ocus   *locus,*oaux;
  struct ocus_rep *rocus,*auxor,*auxrini=NULL;
  struct arbol *pos_var=NULL;
  char sbuf[10];
  int cont=0,longi;
  /*  printf("AQUI ESTAMOS\n");
      verecu(*arb);*/
  u= ocubas_solo_var(arb, &ufin); 
  vbles=0;
  if (u) { /* hay ocurrencias vbles*/

    locus=list_ocu(u,*arb);
    rocus=NULL;
    repet_ocu(locus,&rocus,*arb); 
    oaux=NULL;
    auxrini=rocus;
    auxor=rocus;
    while (auxor)
      {/* solo si hay ms de una vble en la parte izq, sino no tiene sentido*/
	/* la primera vble lgicamente esta en la parte izq*/
	cont=0;
	if ((auxor->posis->sig)&&(auxor->posis->sig->posicion->valor==1))
	  {
	    vbles=1;
	    cont++;
	    for (oaux=auxor->posis;oaux;oaux=oaux->sig)
	      {
		pos_var= ret_ocu_pos(oaux->posicion,oaux->posicion->valor,*arb);
		longi=sprintf(sbuf,"@%d",cont);
		strncpy(pos_var->oc,sbuf,longi+1);
	      }
	  }
	auxor=auxor->sig;
      }
    borraocus(locus);
    borraocus_rep(rocus);
  }
  /*  verecu(*arb);*/
}   

/* elimina las ecuaciones con @2, o las sobrantes que el proceso nos devuelve cuando hacemos crg de ecuaciones con vble */

PRIVATE struct lista *no_ecus_invalidas(struct lista **uini)
{
  struct lista *auxl,*auxlp,*auxl0,*u,*ufin,*auxar;
  
  auxl=*uini;
  auxlp=*uini;
  while(auxl)
    {  /*calculamos ocurrencias no variables*/
      u= ocubas(&(auxl->ecu), &ufin); 
      if (u) 
	{ /* hay ocurrencias no vbles*/
	  for (auxar=u;auxar;auxar=auxar->sig)
	    {
	      if (auxar->ecu->oc[0]=='@') break;
	    }
	  
	  if (auxar!=NULL) 
	    {
	      /*ecuacion invalida*/	
	      if (auxl==*uini) 
		{
		  *uini=(*uini)->sig;
		  auxl->sig=NULL;
		  borralis(auxl);
		  auxl=*uini;
		  auxlp=*uini;
		}
	      else 
		{
		auxlp->sig=auxl->sig; 
		auxl0=auxl;
		auxl=auxl->sig;
		auxl0->sig=NULL;
		borralis(auxl0);}
	    }
	  else 
	    {
	      auxlp=auxl;
	      auxl=auxl->sig;
	    }
	}
      else /* no hay ocurrencias no vbles*/
	{
	  auxlp=auxl;
	  auxl=auxl->sig;
	}	
    }
  return auxlp;
}   

/* no permite ecuaciones con variables extra en la parte derecha*/

PRIVATE struct lista *no_vbles_extra(struct lista **uini)
{
  struct lista *auxl,*auxlp,*auxl0,*u,*ufin;
  struct ocus   *locus,*oaux;
  struct ocus_rep *rocus,*auxor;
  
  auxl=*uini;
  auxlp=*uini;
  while(auxl)
    {  /*calculamos ocurrencias variables*/
      u= ocubas_solo_var(&(auxl->ecu), &ufin); 
      if (u) 
	{ /* hay ocurrencias vbles*/
	  locus=list_ocu(u,auxl->ecu);
	  rocus=NULL;
	  /* eliminacion de la vbles extra a la derecha para ello nos aseguramos que todas las variables tengan presencia en la parte izquierda, o sea tengan alguna posicion que empiece por 1 */
	  repet_ocu(locus,&rocus,auxl->ecu); 
	  oaux=NULL;
	  for (auxor=rocus;auxor;auxor=auxor->sig)
	    {
	      for (oaux=auxor->posis;(oaux)&&(oaux->posicion->valor!=1);oaux=oaux->sig);
	      if  (oaux== NULL) break;
	    }
	  
	  if (oaux==NULL) 
	    {
	      /*vble extra, hay que eliminarla de la lista*/	
	      if (auxl==*uini) 
		{
		  *uini=(*uini)->sig;
		  auxl->sig=NULL;
		  borralis(auxl);
		  auxl=*uini;
		  auxlp=*uini;
		}
	      else 
		{
		auxlp->sig=auxl->sig;  /* modificacion antes cerrabams las llaves aqui*/
		auxl0=auxl;
		auxl=auxl->sig;
		auxl0->sig=NULL;
		borralis(auxl0);}
	    }
	  else 
	    {
	      auxlp=auxl;
	      auxl=auxl->sig;
	    }
	  borraocus(locus);
	  borraocus_rep(rocus);
	}
      else /* no hay ocurrencias vbles*/
	{
	  auxlp=auxl;
	  auxl=auxl->sig;
	}	
      
    }
  return auxlp;
}   

/* genera el rbol de ocuurencias, asi como el arbol con las clases de
   equivalencia*/

PRIVATE void gen_arb_ocus(struct ocus_rep *ocr,struct arbol **arb_ocs,
			  struct arbol **cleq)
{
  struct arbol *auxa,*auxa1=NULL;
  struct arbol *auxa2=NULL;
  struct ocus_rep *auxor;
  struct ocus *auxo;
  int posi=0;
  struct oc_pos *npos;
  
  for (auxor=ocr;auxor;auxor=auxor->sig)
    {
      /*Vamos a crear el arbol de las clases de equivalencia*/
      auxa=nouarbol();
      /* aprovechamos el campo tam para numerar*/
      posi++;
      auxa->tam=posi;
      /* si no es el primero aadimos*/  
      if (*cleq==NULL) *cleq=auxa;
      else auxa1->hijo=auxa;
      auxa1=auxa;
      
      /* el siguiente paso consiste en  construir el arbol de ocurrencias  y
	 ademas rellenar las clases de equivalencia*/
      for (auxo=auxor->posis;auxo;auxo=auxo->sig)
	{
	  auxa2=*arb_ocs;
	  npos=copioc_pos(auxo->posicion);
	  /* vamos generando nodos conforme vamos avanzando (si no existian)
	     y rellenamos los que corresponden solo*/
	  while (npos)
	    {
	      if ((npos->valor==1) &&(npos->sig==NULL))
		{ /* eccolo, ya tenemos la posicion*/
		  /* no existe, la creamos y ademas le damos el valor*/
		  if (!auxa2)
		    {
		      auxa=nouarbol();
		      if(!(*arb_ocs)) *arb_ocs=auxa;
		      auxa2=auxa;
		    }
		  auxa2->tam=posi; 
		  npos=0;
		}
	      else 
		if (npos->valor==1) { 
		  if (!auxa2->hijo)
		    {/* no existe, lo creamos sin rellenar y continuamos*/
		      auxa=nouarbol();
		      auxa2->hijo=auxa;
		    }
		  auxa2=auxa2->hijo;
		  npos=npos->sig;
		}
		else
		  {
		    if (!auxa2->herm)
		      {
			auxa=nouarbol();
			auxa2->herm=auxa;  
		      }
		    npos->valor=npos->valor--;
		    auxa2=auxa2->herm;
		  }
	    }/*while*/
	}/*for*/
    }/*for*/
  
}


/* genera recusrivamente todas las generalizaciones de una ecuacion
   parametros=1 lista de ocurrencias, 2 ecuacion, 3 lista de ecuaciones,
   4 la variable a asignar (si es Null se rellena autmaticamente)*/

PUBLIC void tot_gen(struct ocus *locu,struct arbol *arbocu, struct arbol *arbeq,
		    struct lista *ocu_sub, struct lista **lfin,struct lista **ini)
{
  
  char vb[10];
  struct lista *nou;
  struct arbol *arb,*aux,*aux1,*arbocu1,*arbeq1,*aux2;
  
  if(!locu) 
    {     /* filtro para evitar variables del tipo X=0*/
      if (!arbocu->hijo) return;/*borralis(ocu_sub);*/
      if (!(*ini)) *ini=ocu_sub;
      if (*lfin!=NULL) (*lfin)->sig=ocu_sub;
      ocu_sub->sig=NULL;
      *lfin=ocu_sub;
      return;
    }
  
  tot_gen(locu->sig,arbocu,arbeq,ocu_sub,lfin,ini);
  vb[0]='\0';
  nou=nueva_gen(ocu_sub->ecu,locu->posicion,vb);
  if (nou)
    {        
      arbocu1=copiecu(arbocu);
      arbeq1=copiecu(arbeq);
      arb=ret_ocu_pos(locu->posicion,locu->posicion->valor,arbocu1);		  
      if (arb->hijo) borraecu(arb->hijo);
      arb->hijo=NULL;	  
      /*localizamos su clase de equivalencia */
      for(aux=arbeq1;aux->tam!=arb->tam;aux=aux->hijo);
      /* y le anyadimos la variable*/
      aux2=aux;
      /* le anyadimos la variable a la clase de equivalencia*/	 
      for(;aux->herm;aux=aux->herm);
      aux1=nouarbol();
      strcpy(aux1->oc,vb); 
      aux->herm=aux1;
      /*si no esta en la parte derecha la lanzamos, 
	filtro para evitar vbles extra rhs*/
      if ((locu->posicion->valor)!=2)
	tot_gen(locu->sig,arbocu1,arbeq1,nou,lfin,ini);
      else borralis(nou);
      /* para todas las variables de la clase de equivalencia*/
      for(aux=aux2->herm;aux->herm;aux=aux->herm)
	{
	  nou=nueva_gen(ocu_sub->ecu,locu->posicion,aux->oc);
	  tot_gen(locu->sig,arbocu1,arbeq,nou,lfin,ini);
	}
      borraecu(arbocu1);
      borraecu(arbeq1);
    }
}


/*calcula los crg para una ecuacion dada */
/* paramatros: 1 ecuacion, 2 ejm pos, 3 ejm neg, 4 ultimo elemento, 
   5 ecuaciones anteriores (evita repeticiones)
   6 int indicardor de tipos de crg 
   if ==1 no se mira consistencia positiva y se examina que no hay vbles
   extra parte derecha retorna lista de ecuaciones crg*/

PUBLIC struct lista *crg(struct arbol *ecu,struct lista *ejn,
			 struct lista *ejp, struct lista **lfin, struct lista *ini,int modo)
{
  
  struct arbol *arbeq=NULL,*arboc=NULL;
  struct lista *ut=NULL,*ut1=NULL,*uini1=NULL;
  struct lista  *auxl,*auxi,*auxf,*ufin,*aux3,
    *u; /* puntero a cabeza lista de ocurrencias no
	   variables de una ecuacion de g */
  struct ocus   *locus;
  struct ocus_rep *rocus;
  struct list_var *lv=NULL,*lv1;
  int j,notermina;
  /* generacion de generalizaciones*/
  printf("\n@@@@@@@@@@@ CRG process @@@@@@@@@@@ ");
  asig_var(&ecu);
  u= ocubas(&ecu, &ufin); /* Calcula ocurrencia no var de una ec.*/
  /*pep[0]='\n';
  pep[1]='&';
  pep[2]='\0';*/
  /*verocu(pep,u);*/
  /* monta una lista de ocurrencias (incluida las repetidas)*/
  locus=list_ocu(u,ecu);
  rocus=NULL;
  repet_ocu(locus,&rocus,ecu); 
  gen_arb_ocus(rocus,&arboc,&arbeq);
  ut=noulista();
  ut->ecu=copiecu(ecu);  
  /*llamamos a la funcion que nos genera una lista con las generalizaciones*/
  tot_gen(locus,arboc,arbeq,ut,&ut1,&uini1);
  /*borramos todas las estructuras necesarias*/
  borraocu(u);
  borraecu(arboc);
  borraecu(arbeq);
  borraocus(locus);
  borraocus_rep(rocus);
  if (vbles) no_ecus_invalidas(&uini1);
  /*verlis(pep,uini1);*/
  /*  gets(&c[0]);*/
  j=semilla;
  auxi=uini1;
  /*for(auxl=uini1;auxl;auxl=auxl->sig)		*/
  auxl=uini1;
  while(auxl)
    {		
      semilla=0;
      lv=NULL;
      /* normalizamos*/
      norm_ecu(auxl->ecu,&lv);
      /* borramos la memoria basura*/
      while(lv)
	{
	  lv1=lv;
	  lv=lv->sig;
	  free(lv1);
	}
      /* pequeo test de terminacin*/
      auxf=NULL;
      notermina=solo_vbls_lhs(auxl->ecu);
      if (!notermina)
	{
	  /*comparamos con los anteriores*/
	  for(auxf=ini;auxf;auxf=auxf->sig)		
	    {		
	      if(!auxf) break;
	      if (comp_arb(auxf->ecu,auxl->ecu)) break;
	    }
	}
      /* si ya existe lo eliminamos*/
      if ((notermina)||(auxf))
	{  
	  aux3=auxl;
	  auxl=auxl->sig;
	  /* si es el primero*/
	  if (aux3==uini1) 
	    {
	      uini1=uini1->sig;
	      aux3->sig=NULL;
	      borralis(aux3);
	      auxi=uini1;
	    }
	  else 
	    {
	      auxi->sig=aux3->sig;
	      aux3->sig=NULL;
	      borralis(aux3);	
	    }			
	}	
      else
	{ 
	  auxi=auxl;
	  auxl=auxl->sig;
	}
    }
  semilla=j;
       /* printf("\nCRG sin filtro:\n");
	  verlis("",uini1);
	  printf("\n eliminando....:");*/
  /* si se indica se eliminan las generadas con vbles extra en la parte der*/
     no_vbles_extra(&uini1);
  /* eliminamos las que cubran ejemplos negativos y positivos*/ 
  if (ejemnini) *lfin=no_eje_neg(&uini1);
/*     printf("\n eliminandas negativas. y vbles extra ...:");
       verlis("",uini1);*/
  if (uini1) 
    {
      if(!uini1->ecu)  {printf("\n error, bad positive example"); exit(-1);} 
      /* si se indica comprovamos consistencia positiva*/
      if (modo==0) 
	{  
	  *lfin=eje_pos(&uini1); 
/*	  	    printf ("\n eliminadas positivas:\n");
		    verlis("",uini1);*/
	}
  
  }
  /*calculamos la cobertura de cada regla*/
  /*for(auxf=uini1;auxf;auxf=auxf->sig) 
     cob_ecu(auxf->ecu); */
      
  return(uini1);
}
