/*****************************************************************
 *****************     CRITERIOS          *************************
 ******************************************************************
 FICHERO criter.c: Este modulo contiene los procedimientos que
 permiten calcular algunos criterios para la eleccion de regas.
 Sus unicos puntosde entrada son las funciones:
************************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>


#include <math.h>

#include "const.h"
#include "estruc.h"
#include "glovar.h"

/* Prototipos de funciones externas, definidas en Procesos auxiliares.
   No todas estas funciones son empleadas en "criter.c". */ 
#include "proaux.h"

/* Prototipos de funciones externas, definidas en Fichero de Unificacion
   Sintactica. No todas estas funciones son empleadas en "ob.c". */
#include "unific.h"

/* Prototipos de funciones externas, definidas en Fichero de Unificacion
   Semantica. No todas estas funciones son empleadas en "ob.c". */
#include "narrow.h"
#define tira ""


extern void ver_st();
extern struct stat *genstat(struct lista *obj);
extern struct funcs *gensimesc(struct lista *ini, struct funcs **sbfin);
extern struct lprog *inv_narr(struct prog *r1, struct prog *r2,struct prog **millor,struct lprog **fin,int bkg);
extern struct lista *crg(struct arbol *ecu,struct lista *ejn,
			 struct lista *ejp, struct lista **lfin, 
			 struct lista *ini,int modo);
extern struct lprog *gen_bkg(int p,struct lprog **pfin,struct prog **millorp);
/*extern struct lprog *bkg_regla(struct arbol *p1, struct arbol *p2,struct prog **millor,struct lprog **mfin);*/
/* calcula el numero de variables de una regla*/


/*global al modulo */
int mapa [ATAM][ATAM];





PRIVATE void numvar(struct arbol *arb,int *vars,int *novars)
{
  if (arb==NULL) return; 
  
  /*  if (((arb->oc[0])<96)||(arb->oc[0]=='_')) *vars=*vars +1;*/
  if (  (isupper(arb->oc[0])) ||(arb->oc[0]=='_')) *vars=*vars +1;
  else *novars=*novars+1;
  if (arb->herm!=NULL) numvar(arb->herm,vars,novars);
  if (arb->hijo!=NULL) numvar(arb->hijo,vars,novars);
}

/*longitud de una regla segun agp98 =1+nv/2+nc+nf*/
PUBLIC void agp98(struct arbol *lp)
{
  struct arbol *aux1;
  int vars=0,novars=0;
  float tmp,tmp1; 
  vars=0;
  novars=0;
  /*  aux1=lp->herm;  solo la parte derecha*/
  aux1=lp;   /* toda la ecuacion*/
  numvar(aux1,&vars,&novars);
  tmp=vars;
  tmp1=novars;
  tmp=tmp/2;
  lp->tam=tmp+1+tmp1;
  /*      printf("\n tamany:%d",aux1->tam);*/
 }

/*optimalidad de un programa segun agp98*/
PUBLIC void progagp98(struct prog *pg)
{
  struct lista *laux;
  float sum=0;
  
  for (laux=pg->prg;laux;laux=laux->sig)
    {
      agp98(laux->ecu);
      sum+=laux->ecu->tam;
    }
  pg->tam=log(sum)/log(2);
  
}

/* NOVA VERSIO*/
/* Calcula el numero de ejemplos positivos y negativos que cubre cada
   una de las reglas del programa de entrada (listaini)*/

PUBLIC void cob_regla()
{
  
  struct lista *auxl,*auxlp,*auxe,*auxep;
  struct stat *S, /* puntero al estado de narrowing inicial */
    *E; /* puntero a la lista de estados de exito.
	   Contienen las repuestas computadas. */
  struct funcs *funes;
  
  auxlp=noulista();
  auxep=noulista();
  
  for (auxl=listaini;auxl;auxl=auxl->sig)
    {
      auxl->ecu->nejp=0;
      auxl->ecu->nejn=0;
      auxlp->ecu=auxl->ecu;
      /* ejemplos positivos*/
      
      for (auxe=ejempini;auxe;auxe=auxe->sig)
	{    
	  auxep->ecu=auxe->ecu;
	  start_st('C');
	  gensimesc(auxlp,&funes);
	  S = genstat(auxep);
	  E = narrower(S,auxlp,funes,1); borrastat(S);
	  if (E!=NULL) {auxl->ecu->nejp++;
	  }
	  borrastat(E);borrafun(funes);
	  stop_st();
	}
      printf("\n ejemplos positivos cubiertos :%d",auxl->ecu->nejp);
      
      /* ejemplos negativos*/
      
      for (auxe=ejemnini;auxe;auxe=auxe->sig)
	{    
	  auxep->ecu=auxe->ecu;
	  start_st('C');
	  gensimesc(auxlp,&funes);
	  S = genstat(auxep);
	  E = narrower(S,auxlp,funes,1); borrastat(S);
	  if (E!=NULL) {auxl->ecu->nejn++;}
	  borrastat(E);borrafun(funes);
	  stop_st();
	}
      printf("\n ejemplos negativos cubiertos :%d",auxl->ecu->nejn);
    }
  /*evita que se borren ecuaciones de la teoria*/
  auxlp->ecu=NULL;
  auxep->ecu=NULL;
  borralis(auxlp);
  borralis(auxep);
}


/*  comprueba la cobertura positiva de una regla*/
PUBLIC void cob_ecu(struct arbol *ecua)
{
  struct lista *auxlp,*auxe,*auxep;
  struct stat *S, /* puntero al estado de narrowing inicial */
    *E; /* puntero a la lista de estados de exito.
	   Contienen las repuestas computadas. */
  struct funcs *funes;
  
  auxlp=noulista();
  auxep=noulista();
  auxlp->ecu=ecua;
  /* ejemplos positivos*/
  for (auxe=ejempini;auxe;auxe=auxe->sig)
    {    
      auxep->ecu=auxe->ecu;
      start_st('C');
      gensimesc(auxlp,&funes);
      S = genstat(auxep);
      E = narrower(S,auxlp,funes,1); borrastat(S);
      if (E!=NULL) auxlp->ecu->nejp++;
      borrastat(E);borrafun(funes);
      stop_st();
    }
  /* printf("\n ejemplos positivos cubiertos por la nueva regla :%d",auxlp->ecu->nejp);*/
  /* ejemplos negativos (en principio no hace falta ya se sabe que no cubre)*/
  
  /*      for (auxe=ejemnini;auxe;auxe=auxe->sig)
	  {    
	  auxep->ecu=auxe->ecu;
	  start_st('C');
	  gensimesc(auxlp,&funes);
	  S = genstat(auxep);
	  E = narrower(S,auxlp,funes,1); borrastat(S);
	  if (E!=NULL) {auxl->ecu->nejn++;}
	  borrastat(E);borrafun(funes);
	  stop_st();
	  }
	  printf("\n ejemplos negativos cubiertos :%d",auxl->ecu->nejn);
	  }*/
  /*evita que se borren ecuaciones de la teoria*/
  auxlp->ecu=NULL;
  auxep->ecu=NULL;
  borralis(auxlp);
  borralis(auxep);
}



/* Calcula el numero de ejemplos positivos y/o negativos que cubre un program  se calculan los ejemplos positivos o negativos segun los punteros de los  ej*/

PUBLIC void cob_prog(struct prog *mprog, struct lista *ejp,struct lista *ejn)
{
  
  struct lista *auxe,*auxep;
  struct stat *S, /* puntero al estado de narrowing inicial */
    *E; /* puntero a la lista de estados de exito.
	   Contienen las repuestas computadas. */
  struct funcs *funes;
  struct cobert *auxc=NULL,*auxc1=NULL;
  int i=0,l,k,j,g=0;
  l=sizeof(int)*8;
  
  auxep=noulista();  
  gensimesc(mprog->prg,&funes);
  mprog->nejn=0;
  if (ejn)
    {
      /* ejemplos negativos*/
      
      for (auxe=ejn;auxe;auxe=auxe->sig)
	{    
	  auxep->ecu=auxe->ecu;
	  start_st('C');
	  S = genstat(auxep);
	  E = narrower(S,mprog->prg,funes,1); 
	  borrastat(S);
	  if (E!=NULL) 
	    {
	      mprog->nejn++;
	      borrastat(E);
	      stop_st();
	      break;
	    }
	  borrastat(E);
	  stop_st();
	}
      /*printf("\n ejemplos negativos cubiertos :%d",mprog->nejn);*/
    }
  
  /* solo claculamos la cobertura positiva si se indica, y ademas no
     cubre ningun negativo*/
  if ((ejp)&&(mprog->nejn==0) )
    {
      mprog->nejp=0;
      mprog->cob=NULL;
      i=0;k=0;
      
      g=0; 
      for (auxe=ejp;auxe;auxe=auxe->sig)
	{    
	  auxep->ecu=auxe->ecu;
	  start_st('C');
	  S = genstat(auxep);
	  E = narrower(S,mprog->prg,funes,1); 
	  borrastat(S);
	  j=i%l;
	  if (j==0)
	    {
	      g++;
	      if ((auxc=(struct cobert *) malloc(sizeof(struct cobert))) == NULL)
		memerror();
	      auxc->mapa=0;auxc->sig=NULL;
	      if (mprog->cob==NULL) mprog->cob=auxc;
	      else auxc1->sig=auxc;
	      auxc1=auxc;
	    }
	  if (E!=NULL)
	    {
	      mprog->nejp++;
	      k=pow(2,j);
	      auxc->mapa+=k;
	    }
	  borrastat(E);
	  stop_st();
	  i++;
	}
      /*printf("\n ejemplos positivos cubiertos :%d",mprog->nejp);*/
      printf("num %d, mapas %d",i,g); 
    }
  /*evita que se borren ecuaciones de la teoria*/
  auxep->ecu=NULL;
  
  borrafun(funes);
  borralis(auxep);
}


/* critero de optimalidad */

PUBLIC void opti(struct prog *pg)
{
  float tmp;
  tmp=(ALFA*pg->tam)+(BETA*pg->nejp);
  pg->opt=log(tmp)/log(2);
  pg->opt=tmp;
}

/* funcin para eliminar reglas que no aportan nada*/
PRIVATE void rmv_red(struct prog **lecu)
{
struct lista *aux,*exc,*laste;
int nejp1;
float tam1;
double opt1;
int bkg1;
int flag=0;

nejp1=(*lecu)->nejp;
tam1=(*lecu)->tam;
opt1=(*lecu)->opt;
bkg1=(*lecu)->bkg;
laste=NULL;

/* si solo hay una lista salimos*/
if((*lecu)->prg->sig==NULL) return;

/* se va prueba eliminando cada una de las reglas una a una y si vemos que
no disminuye el nNo de ejem cubiertos lo eliminamos del todo */
 
for (aux=(*lecu)->prg;(aux)&&(aux!=listaini);aux=aux->sig)
  {
    exc=aux;
    if(!laste) (*lecu)->prg=exc->sig;
    else
      {
	laste->sig=exc->sig;
      }
    cob_prog((*lecu),ejempini,NULL);
    if ((*lecu)->nejp<nejp1)
      {
	if (laste) laste->sig=exc;
	else (*lecu)->prg=exc;
      }
    else 
      {
	flag=1;
	/*borrar ecu*/
	exc->sig=NULL;
	borraecu(exc->ecu);
      }

    laste=aux;
  }

 if (flag==0)
   {
     (*lecu)->nejp=nejp1;
     (*lecu)->tam=tam1;
     (*lecu)->opt=opt1;
     (*lecu)->bkg=bkg1;
     
   }
 else
   {
     progagp98(*lecu);
     opti(*lecu);
   }
   
}



/* funcion que determina si un proggrama es lo suficientemente bueno como para detener  el proceso: 1 parar 0 seguir*/

PUBLIC int criterio_parada(struct prog *p2)
{
  FILE *f,*aux;
  /* en principio paramos si cubre todos los ejemplos*/
  if (numejp==p2->nejp)  {
    
    printf ("\n &&&&&&&&&&&&&&&& Solution program &&&&&&&&&&&&&\n");
    verlis  (tira,p2->prg);
    printf (" Number of examples covered: %d, optimality %f",p2->nejp,p2->opt);
    rmv_red(&p2);
    printf ("\n\n &&&&&&&&&&&&&&&& Filtered solution program &&&&&&&&&&&&&\n");
    verlis  (tira,p2->prg);
    printf (" Number of examples covered: %d, optimality %f\n\n",p2->nejp,p2->opt);
    f=fopen("solution.ple","w");
    aux=out;
    out=f;  
    printlis(p2->prg);
    fclose(f);
    out=aux;
    return 1;
  }

  else return 0;
}



/*dado un programa elimina las repeticiones de ecuaciones en un programa*/

PUBLIC void no_rep_ecuacions(struct prog **program)
{
  struct lista *aux,*aux2,*aux3;


  for (aux=(*program)->prg;(aux && aux->sig);aux=aux->sig)
    {
      aux3=aux;
      for (aux2=aux->sig;aux2;aux2=aux2->sig)
	{
	  if (comp_arb(aux->ecu,aux2->ecu))
	    {
	      aux3->sig=aux2->sig;
	      /*borraecu(aux2);*/
	    }
	  else aux3=aux2;
	}
    }
}
  

/* Inicia el bucle principal*/  

PUBLIC struct lprog *init_loop(struct lista *ejp,struct lista *ejn,struct prog **best,struct lprog **lfin)
{
  struct lista *aux,*uaux,*ufin,*ini=NULL,*fin=NULL;
  struct prog *pg,*millor=NULL;
  struct lprog *lpg,*lpaux,*lpini=NULL,*lpax=NULL;
  int k=0,num=0,nfin=ATAM/2;
  /* calculamos todos los crgs para los ejemplos positivos*/
  /*  for (aux=ejp;(aux)&&(j<2);aux=aux->sig) j++;
      aux->sig=NULL; */
  /* printf ("jola"); */
  for (aux=ejp;aux;aux=aux->sig)
    {
      uaux=crg(aux->ecu,ejp,ejn,&ufin,ini,0);
      if (!ini) ini=uaux;
      if (fin) fin->sig=uaux;
      if (ufin) fin=ufin; 
    }
  printf("\nInitial CRG Equations \n");
  verlis(tira,ini);
  /*gets(&c);*/
  /*construimos un programa con cada ecuacion y calculamos su cobertura*/
  /* MEJORA juntar los dos bucles*/
  for (aux=ini;aux;aux=aux->sig)
    { num++;
      pg=nouprog();
      uaux=noulista();
      uaux->ecu=aux->ecu;
      pg->prg=uaux;
      cob_prog(pg,ejp,NULL);
      progagp98(pg);
      opti(pg);
      /* en este  caso coincide la cob del prog con la de la regla (solo hay una regla)*/
      pg->prg->ecu->nejp=pg->nejp;
      printf("\ncoverage of program %d: %d positives, map %d",k,pg->nejp,pg->cob->mapa);
      k++;
      if (!millor) millor=pg;
      else
	if ((millor->nejp)<=(pg->nejp)) 
	  {	
	    if ((millor->nejp)<(pg->nejp)) 
	      {
		millor=pg;
	      }
	    else 
	      {
		if (pg->opt>millor->opt) 
		  {
		    millor=pg;
		  }
	      }
	  }	
      if(k>nfin)
	{
	  /*es peor que el peor actual pasamos de el*/
	  if ((lpini->pro->nejp<pg->nejp)||
	            ((lpini->pro->nejp==pg->nejp)&&(lpini->pro->opt>pg->opt))) 
	    {
	      borraprog(pg);
	      continue;
	    }
	}
	 
	    
      lpg=noulprog();
      lpg->pro=pg;
      if (!lpini) {lpini=lpg;lpaux=lpg;}
      else insl_ord(&lpini,&lpaux,lpg);
      if (num>nfin) 
	{/* como ya no hay mas espacio y hemos insertado en orden 
	    borramos el peor que es el primero*/
	  lpax=lpini->sig;
	  borraprog(lpini->pro);
	  free(lpini);
	  lpini=lpax;
	}
    
	  
      /*      else {lpaux->sig=lpg;lpaux=lpg;}*/
    }
  /*   printf("\nmejor programa %d:%d positivos, mapa %d, optimalidad %f"
       ,t,millor->nejp,millor->cob->mapa,millor->opt);*/

  *best=millor;
  if (lpaux) *lfin=lpaux;
  return lpini;
}


/* union de dos programas*/

PUBLIC struct lprog *union_progs(struct prog *prog1,struct prog *prog2)
{
  struct lista *aux,*uaux,*ini=NULL,*ant=NULL,*ant1=NULL;
  struct prog *pg;
  struct lprog *lpg;

  
  for (aux=prog1->prg;aux;aux=aux->sig)
    {
      uaux=noulista();
      uaux->ecu=aux->ecu;
      if (!ini) ini=uaux;
      if (ant) ant->sig=uaux;
      ant=uaux;
    }
  for (aux=prog2->prg;aux;aux=aux->sig)
    {
      uaux=noulista();
      uaux->ecu=aux->ecu;
      if (!ant->sig) ant->sig=uaux;
      if (ant1) ant1->sig=uaux;
      ant1=uaux;
    }
  
  pg=nouprog();
  pg->prg=ini;
  no_rep_ecuacions(&pg);
  lpg=noulprog();
  lpg->pro=pg;
  
  return lpg;
}


/*une dos programas, y calcula su optimalidad*/

PUBLIC void union_optim(struct prog *p1,struct prog *p2,struct lprog **mpr)
{
  struct lprog *nou;
  /*if (*mpr){(*mpr)->pro->prg->ecu=NULL;(*mpr)->pro->prg->sig=NULL;borraprog((*mpr)->pro);}*/
  nou=union_progs(p1,p2);
  progagp98(nou->pro);
  cob_prog(nou->pro,ejempini,ejemnini);
  opti(nou->pro);
  *mpr=nou;
}


/*aplica los dos operadores y se queda con el que resulte mejor*/

PRIVATE struct lprog *operador (struct prog *millor,struct prog *millor1,struct prog **mna,struct lprog **fin)
{
  struct lista *laux,*laux2;
  struct lprog *nou,*nou2;
  
  /* narrowing inverso*/
  nou=inv_narr(millor,millor1,mna,fin,0);
  /* salimos directamente ya no hacemos la union*/
  printf ("\n Best program:\n");
  if (*mna) 
    {
      verlis(tira,(*mna)->prg);
      /*      printf("\n num ejemplos cubiertos:%d \n ",(*mna)->nejp);*/
    }
 if (nou)  return nou;

     /*creamos un programa nuevo  union de los mejores */
     union_optim(millor,millor1,&nou2);
     printf ("\n Inverse Narrowing has failed, Union is performed   \n");
     printf ("\n Union program:  \n");
     verlis(tira,nou2->pro->prg);
     printf("\ncoverage of union program :%d positives, %d negatives map %d,optimality%f",nou2->pro->nejp,nou2->pro->nejn,nou2->pro->cob->mapa,nou2->pro->opt);
  /*gets(&c);*/
  if (nou) 
    {
   /* se ha calculado la union y narrowing inverso, nos quedamos con el mejor*/
        if (nou2->pro->nejp > (*mna)->nejp) 
	{
     /* la union es mejor, nos quedamos con ella y borramos el narrowing inv*/
	  /*BORRAR LISTA DE PROGRAMAS*/
	  nou=nou2;
	  *mna=nou2->pro;
	}
      else 
	{  /* el Narr Inv es mejor borramos la union*/ 
				/*borramos el creado*/
	  for(laux=nou2->pro->prg;laux;laux=laux2)
	    {
	      laux->ecu=NULL;
	      laux2=laux->sig;
	      free(laux);
	    }
	  nou2->pro=NULL;
	  free(nou2);
	}      
    }
  else 
    {/*  no se puede hacer narrowing inverso se opta por la union*/
      nou=nou2;
      *mna=nou->pro;
    }
 
  printf ("\n Best program:\n");
  verlis(tira,(*mna)->prg);
  return nou;
}

/* primera iteracion del bucle, rellena el mapa con los programas iniciales*/

PRIVATE int llena_mapa(struct lprog *listprg,int *max,struct prog **millor,struct prog **millor1,struct lprog **pfin,double *optim)
{  
  struct lprog *auxp,*auxp1;
  int i,j,nej,jf1=0,jf2=0;
  unsigned int mres,fres,res;
  struct cobert *auxcob,*auxcob1;
  struct prog *auxpr,*auxpr1;
  double opaux;
  
  i=0;
  for(auxp=listprg;auxp->sig;auxp=auxp->sig)
    {
      j=1;	
      /* montaje para comprobrar la cobertura de todos los ejemplos*/
      for(auxp1=auxp->sig;auxp1;auxp1=auxp1->sig)
	{
	  auxcob1=auxp1->pro->cob;
	  nej=0;
	  for(auxcob=auxp->pro->cob;auxcob;auxcob=auxcob->sig)
	    {
	      mres=auxcob1->mapa|auxcob->mapa;
	      auxcob1=auxcob1->sig;
 /* cuenta el n de ejemplos que se cubre con la union de las dos reglas*/
	      for (res=mres;res!=0;res=res>>1) 
		if((res%2)==1) nej++;
	    } 
	  mapa[i][j+i]=nej;
	  if (*max==0) 
	    {
	    (*max)=nej;
	    fres=mres;
	    *millor=auxp->pro;
	    *millor1=auxp1->pro;
	    *optim=auxp->pro->opt+auxp1->pro->opt;
	    jf1=i;
	    jf2=j+i;
	    }
	  else 
	    if (nej>*max) 
	      {
		*max=nej;
		fres=mres;
		*millor=auxp->pro;
		*millor1=auxp1->pro;
		*optim=auxp->pro->opt+auxp1->pro->opt;
		jf1=i;
		jf2=j+i;
	      }
	    else 
	      if (nej==*max) 
		{ 
		  auxpr=auxp->pro;
		  auxpr1=auxp1->pro;
		  opaux=auxp->pro->opt+auxp1->pro->opt;
		  if (opaux<=*optim)
		    {
		      *max=nej;
		      fres=mres;
		      *millor=auxp->pro;
		      *millor1=auxp1->pro;
		      *optim=auxp->pro->opt+auxp1->pro->opt;
		      jf1=i;
		      jf2=j+i;
		      *optim=opaux;
		    }
		}
	  j++;
	}
      i++;
    }	

  mapa[jf1][jf2]=0;
  *pfin= auxp;
  printf("\n 1 Best program: number %d, %d positives, mapa %d"
	 ,jf1,(*millor)->nejp,(*millor)->cob->mapa);
  printf("\n 2 Best program: number %d, %d positives, mapa %d"
	 ,jf2,(*millor1)->nejp,(*millor1)->cob->mapa);
  /*  printf("\n num ej cubiertos: %d, mapa %d",*max,fres);*/
  return i;
}

/* actualiza el mapa a partir de una serie de programas apuntados por nou*/

PRIVATE int actualiza_mapa(struct lprog *listprg,struct lprog *nou,int *max,struct prog **millor,struct prog **millor1,struct lprog **pfin,double *optim,int *i3)
{  
  struct lprog *auxp,*auxp1;
  int i,j=0,test=0,nej,jf2=0,jf1=0,ia=0,ja=0,max2=0,ia1=0,ja1=0;
  unsigned int mres,fres,res;
  struct cobert *auxcob,*auxcob1;
  struct prog *auxpr,*auxpr1;
  double opaux;
  
  i=0;
  for(auxp=listprg;auxp!=nou;auxp=auxp->sig)
    {
      j=*i3;	
      /* montaje para comprobrar la cobertura de todos los ejemplos*/
      for(auxp1=nou;auxp1;auxp1=auxp1->sig)
	{
	  auxcob1=auxp1->pro->cob;
	  nej=0;
	  for(auxcob=auxp->pro->cob;auxcob;auxcob=auxcob->sig)
	    {
	      mres=auxcob1->mapa|auxcob->mapa;
	      auxcob1=auxcob1->sig;
 /* cuenta el n de ejemplos que se cubre con la union de las dos reglas*/
	      for (res=mres;res!=0;res=res>>1) 
		if((res%2)==1) nej++;
	    } 
	  /* potenciamos a los programas con bkg*/
	  if (auxp->pro->bkg||auxp1->pro->bkg) 
	    {
	      nej+=2;
	      /*	      printf("ecu bkg");*/
	    }
	  mapa[i][j+i]=nej;
	  if (*max==0) 
	    {
	    (*max)=nej;
	    fres=mres;
	    *millor=auxp->pro;
	    *millor1=auxp1->pro;
	    *optim=auxp->pro->opt+auxp1->pro->opt;
	    jf1=i;
	    jf2=j+i;
	    test=1;
	    }
	  else 
	    if (nej>*max) 
	      {
		*max=nej;
		fres=mres;
		*millor=auxp->pro;
		*millor1=auxp1->pro;
		*optim=auxp->pro->opt+auxp1->pro->opt;
		jf1=i;
		jf2=j+i;
		test=1;
	      }
	    else 
	      if (nej==*max) 
		{ 
		  auxpr=auxp->pro;
		  auxpr1=auxp1->pro;
		  opaux=auxp->pro->opt+auxp1->pro->opt;
		  if (opaux<=*optim)
		    {
		      *max=nej;
		      fres=mres;
		      *millor=auxp->pro;
		      *millor1=auxp1->pro;
		      *optim=auxp->pro->opt+auxp1->pro->opt;
		      jf1=i;
		      jf2=j+i;
		      *optim=opaux;
		      test=1;
		    }
		}
	  j++;
	}
      i++;
    }	
  *i3=j;
  *pfin= auxp;
  
      /* ahora faltara la seleccin del mejor segun el mapa....*/
  for (ia=0;ia!=*i3;ia++)
    for (ja=ia+1;ja<=*i3;ja++)
      {	
	if (mapa[ia][ja]>max2) {max2=mapa[ia][ja];ia1=ia;ja1=ja;}
      }
  
  /*  printf ("\nvalor del mapa %d %d = %d",ia1,ja1,mapa[ia1][ja1]);
      printf ("\nvalor del maximo %d %d = %d",jf1,jf2,mapa[jf1][jf2]);*/
  
  /*  if (mapa[ia1][ja1]>mapa[jf1][jf2]) 
    {
      printf("\nAtencion valor en mapa mayor, modificar prog");
      exit(-2);
      }*/
      
  /* ponemos a 0 su mapa*/
  mapa[jf1][jf2]=0;
  if (test)
    {
      printf ("\n Best program 1 :\n");
      verlis(tira,(*millor)->prg);
      printf(" Coverage program %d: %d positives, mapa %d"
	     ,jf1,(*millor)->nejp,(*millor)->cob->mapa);
      printf ("\n Best program 2 :\n");
      verlis(tira,(*millor1)->prg);
      printf(" Coverage program %d: %d positives, mapa %d"
	     ,jf2,(*millor1)->nejp,(*millor1)->cob->mapa);
    }
  return test;
  
}


/* bucle principal*/

PUBLIC void main_loop()
{
  struct lista *laux;
  struct prog *millor=NULL,*millor1=NULL,*mna=NULL,*mna1=NULL,*mnat=NULL,
              *ptmp=NULL;
  struct lprog *listap,*auxp,*nou=NULL,*calp=NULL,*fin=NULL,*lbkg=NULL,
        *fin2=NULL,*auxp2=NULL,*lfin=NULL;
  int k=1,i,j,max=0,maxant=0,fres=0,i3;
  int test=0,countk=0;
  double optim=0; 
  
  for (i=0;i<ATAM;i++)
    for (j=0;j<ATAM;j++) mapa[i][j]=0;  

   /* contamos cuantos ejemp positivos*/
  numejp=0;
  for(laux=ejempini;laux;laux=laux->sig) numejp++;

  /*ver_st();*/
  /* calcula los crg de E+*/
  listap=init_loop(ejempini,ejemnini,&millor,&lfin);
  /*ver_st();*/
  if (millor)
    if (criterio_parada(millor)) return;	

  /*llenamos mapa*/
  i3=llena_mapa(listap,&max,&millor,&millor1,&auxp,&optim);
 /*ver_st();*/
  if (union1) /*si esta puesta en ON, probamos con la unin de los dos mejores*/
    {
      union_optim(millor,millor1,&auxp2);
      if (criterio_parada(auxp2->pro)) return;
      /* lo metemos al final*/
      lfin->sig=auxp2;
      auxp2=NULL;
      lfin=lfin->sig;
    }
  maxant=millor->nejp;
    
  /* invocamos los operadores con los dos mejores*/
 if (!listaini) nou=operador(millor,millor1,&mna,&fin);
 if (mna) 
   {
     if (criterio_parada(mna)) return;
   }
 else
   {
     if (listaini)
       {  
	 /*lbkg=gen_bkg(countk++,&fin,&mna);*/
	 /*probamos es un sentido*/
	 printf("\n\n ^^^^^^^^ Introducing background ^^^^^^^");
	 printf("\n ^^^^^^^^  with the equation 1   ^^^^^^^");
	 ptmp=nouprog();
	 ptmp->prg=listaini;
	 lbkg=inv_narr(ptmp,millor1,&mna,&fin,1);
	 ptmp->prg=NULL;
	 borraprog(ptmp);
	 if (mna) mnat=mna;
	 if (mna) auxp2=operador(millor,mna,&mna1,&fin2);
	 if (mna1) mnat=mna1;
	 if(fin) fin->sig=auxp2;
	 if (fin2) fin=fin2;
	 fin2=NULL;
	 if (lbkg) nou=lbkg;
	 if (mna1) {if (criterio_parada(mna1)) return;}
	 /* probamos en el otro sentido*/
	 printf("\n ^^^^^^^^ Introducing background ^^^^^^^");
	 printf("\n ^^^^^^^^   with the equation 2  ^^^^^^^");
	 mna=NULL;mna1=NULL;
	 ptmp=nouprog();
	 ptmp->prg=listaini;
	 /*     	 lbkg=inv_narr(laux->ecu,millor,&mna,&fin2);*/
	 lbkg=inv_narr(ptmp,millor,&mna,&fin2,1);
	 ptmp->prg=NULL;
	 borraprog(ptmp);
	 if (fin) fin->sig=lbkg;
	 if (fin2) fin=fin2;
	 fin2=NULL;
	 if (mna) auxp2=operador(millor1,mna,&mna1,&fin2);
	 if (mna) mnat=mna;
	 if(fin) fin->sig=auxp2;
	 if (fin2) fin=fin2;
	 if (mna1) {if (criterio_parada(mna1)) return;}
	 if (mna) mnat=mna1;
	 if ((!nou)&&(lbkg)) nou=lbkg;
	 mna=mnat;
	 if (mna) 
	    {
	      if (criterio_parada(mna)) return;
	    }
       }
   }
 /*ver_st();*/ 
 if(!mna) mna=millor;
 if(!fin) fin=auxp;
 auxp->sig=nou;
/*  printf("kk\n"); */
/*  if (mna) printf("\n mapa ej cubiertos tras Narr inv: %d",mna->cob->mapa); */
/*  if (mna) printf("\n num ej cubiertos tras Narr inv: %d",mna->nejp); */
 /* printf ("\n******************* Antes de entrar en bucle ************");*/
 /*gets(&c);*/
 /* ponemos a 0 su mapa*/
 
 /* criterio de parada: k pasos o ejemplos cubiertos = n ejemplos*/
 if ((!nou)&&(!listaini)) test=0;
 else test=1;
 calp=nou;
  
 while ((k<msteps)&&(test))
   {	
     printf ("\n********************* Step number %d *********************",k);
     /*	gets(&c);*/
     
     if ((mna) && (maxant>=mna->nejp) && (listaini))
       {
	 /* no se ha mejorado en numero de ejemplos probamos con el bkg*/
	 /*	 printf(" \n Background equations:%d  %d\n",maxant,mna->nejp);*/
	 if ( ninv_bkg_tipo==0) lbkg=gen_bkg(countk++,&fin2,&mna1);
	 else 
	   {
	     ptmp=nouprog();
	     ptmp->prg=listaini;
	 /*     	 lbkg=inv_narr(laux->ecu,millor,&mna,&fin2);*/
	     lbkg=inv_narr(ptmp,millor,&mna1,&fin2,1);
	     ptmp->prg=NULL;
	     borraprog(ptmp);
	     /*   lbkg=inv_narr(laux->ecu,millor->prg->ecu,&mna1,&fin2);*/
	   }	     
	 
	 if (lbkg) fin->sig=lbkg; 
	 if (fin2) fin=fin2; 
	 if(!calp) calp=lbkg;
	  /* getchar();*/
       }
     /* aadimos al mapa la confrontacion de los nuevos programas con los 
	viejos*/
     max=mna->nejp;
     maxant=max;
     optim=mna->opt;
     i=0;
     test=0;
     nou=calp;
     test=actualiza_mapa(listap,nou,&max,&millor,&millor1,&auxp,&optim,&i3);
     
     if (test) 
       {
	 calp=operador(millor,millor1,&mna,&fin);
	 if (calp) {if (criterio_parada(mna)) return;}
	 else test=0;
	 auxp->sig=calp;		
       }
     
     k++;			
   }	
 printf("\n Best program 1 :%d positives, map %d"
	,millor->nejp,millor->cob->mapa);
 printf("\n Best program 2 :%d positives, map %d"
	,millor1->nejp,millor1->cob->mapa);
 printf("\n num ej cubiertos: %d, mapa %d",max,fres);
 if (nou)  printf("\n mapa ej cubiertos realmente: %d",nou->pro->cob->mapa);
}
