/*********************** VARIABLES GLOBALES *******************************
FICHERO glovar.h: Este fichero de cabecera agrupa todas las variables
globales. Debera utilizarse al principio de cada modulo, para que las
variables queden declaradas como externas. La definicion (reserva de memoria),
se hace en un solo punto del programa, el fichero main.c, en el que habra que
redefinir la constante EXTERN antes de proceder a la inclusion de esta
cabecera.
****************************************************************************/


/* fichero de salida abierto durante las primeras fases del
analisis sintactico y utilizado por procedimientos auxiliares
de visualizacion y en otros puntos del programa (mensajes de
error etc.) */
EXTERN FILE *out;

/* punteros a la lista de ecs. que almacenan la teoria */
EXTERN struct lista   *listaini, *listafin;

/* punteros a la lista de simbolos/aridad de la teoria: Signatura */
EXTERN struct funcs   *funcini, *funcfin;

/* punteros a la lista de simbolos reescribibles de la teoria: Signatura */
EXTERN struct funcs   *funescini, *funescfin;

/* punteros a la lista de ecs. que almacenan ejemplos positivos*/
EXTERN struct lista   *ejempini, *ejempfin;

/* punteros a la lista de ecs. que almacenan ejemplos positivos*/
EXTERN struct lista   *ejemnini, *ejemnfin;

/* punteros a la lista de ecs. flat generadas a partir del objetivo  */
EXTERN struct lista   *fgoalini, *fgoalfin;
 
/* impone un numero de orden a las variables frescas */
EXTERN unsigned int semilla;

/* Variable en la que se almacena el deseo de que el programa realice
una traza de los calculos que esta realizando. Por defecto almacena el
valor NTRACE, no trazar calculos. */
EXTERN int trace;

/* Variable para el tratamiento estadstico de los calculos. */
EXTERN struct estadis st;

EXTERN int bkg; /* indica si se utiliza el bkg para los crg*/


 /*num ejemplos positivos*/
EXTERN int numejp;

EXTERN int terminacion; /* indica si se efectua  el pequeo test de terminacin */

EXTERN int union1;   /* Indica si se utiliza o no la union (en principio solo la primera pasada)*/

EXTERN int ninv_bkg_tipo; /*Indica si se efectua el Narrinv cuando hay background con ejemplos (=0) o con las reglas del bkg (=1)*/

EXTERN int mul_inv_nar;  /* efectua  Narr. Inv. entre  todas las reglas de un programa (por parejas) o solo entre las mejores*/

EXTERN int stop_now;  /* Stops inmediatly when it is found a program that covers all the examples*/

EXTERN long int prof;     /* Profundidad maxima que puede alcanzar Narrowing
			     evita que se entre en bucles infinitos*/
EXTERN long int msteps; /* numero maximo de pasos del bucle proncipal*/
